#include <cstdio>
#include <vector>
#include <algorithm>
#include <cstdlib>
#include <ctime>
#include <cstring>

#define POPULATION_SIZE 250
#define OLD 15
#define NUMBER_OF_POPULATIONS 1
//^obsolete
#define MUTATION_RATE 0.03
#define NUMBER_OF_TRIALS 15

using namespace std;

int n,m,p;

struct animal
{
    int row,col,k,thr;
    int pat[16][16];
};

animal an[128];

int mat[64][64];

struct chromosome
{
    int index[128],row[128],col[128],fitness;
};

chromosome population[2][POPULATION_SIZE+6];

struct data
{
    int index,rank;
};

data toSort[128];

inline int random(const int &a, const int &b)
{
    int res = rand()%(b-a+1);
    return res + a;
}

bool f(const data &u, const data &v)
{
    if ( u.rank > v.rank ) return true;
    if ( u.rank == v.rank && u.index > v.index ) return true;
    return false;
}

inline bool mutation()
{
    int ran = random(1,10000);
    if ( ran <= 10000*MUTATION_RATE ) return true;
    return false;
}

void greedy_generator()
{
    chromosome current;
    int matLoc[64][64];

    int sum,i,j,flag,x,y,br,bottom,perm[128],used[128],bestx,besty,best,ind;
    for ( i=1; i<=POPULATION_SIZE; i++ )
    {
        memcpy(matLoc,mat,16384);

        for ( j=1; j<=p; j++ )
        {
            used[j] = 0;
            current.index[j] = p + 1;
        }

        bottom = p-10;
        if ( bottom < 0 ) bottom = 1;
        br = random(bottom,p);
        br = p;

        for ( j=1; j<=br; j++ )
        {
            perm[j] = random(1,p);
            while ( used[ perm[j] ] )
            {
                perm[j]++;
                if ( perm[j] > p ) perm[j] = 1;
            }
            used[ perm[j] ] = 1;
        }

        ind = 1;

        current.fitness = 0;

        for ( j=1; j<=br; j++ )
        {
            bestx = -1;
            best = 0;
            for ( x=1; x<=n-an[ perm[j] ].row+1; x++ )
                for ( y=1; y<=m-an[ perm[j] ].col+1; y++ )
                {
                    flag = sum = 0;

                    for ( int g=x; g < x + an[ perm[j] ].row; g++ )
                        for ( int h=y; h < y + an[ perm[j] ].col; h++ )
                            if ( an[ perm[j] ].pat[g-x+1][h-y+1] )
                            {
                                if ( matLoc[g][h] < an[ perm[j] ].thr )
                                {
                                    flag = 1;
                                    break;
                                }
                                sum += matLoc[g][h];
                            }

                    if ( (!flag) && sum > best)
                    {
                        best = sum;
                        bestx = x; besty = y;
                    }
                }

            if ( bestx != -1 )
            {
                current.fitness += best;
                current.index[ perm[j] ] = ind;
                current.row[ perm[j] ] = bestx;
                current.col[ perm[j] ] = besty;

                for ( int g=bestx; g < bestx + an[ perm[j] ].row; g++ )
                        for ( int h=besty; h < besty + an[ perm[j] ].col; h++ )
                            if ( an[ perm[j] ].pat[g-bestx+1][h-besty+1] )
                                matLoc[g][h] /= an[ perm[j] ].k;

                ind++;
            }
        }

        population[0][i] = current;
    }
}

chromosome crossover(chromosome &u, chromosome &v)
{
    int matLoc[64][64];
    int i,j,indPar,childI=1,x,y;

    memcpy(matLoc,mat,16384);

    chromosome* parents[2];
    parents[0] = &u;
    parents[1] = &v;

    for ( i=1; i<=p; i++ )
    {
        toSort[i].index = i;
        toSort[i].rank = 2*p + 2 - (u.index[i] + v.index[i]);
    }

    sort (toSort+1,toSort+p+1,f);

    chromosome childInTime;

    childInTime.fitness = 0;
    for ( i=1; i<=p; i++ ) childInTime.index[i] = p + 1;

    bool flag;

    for ( i=1; i<=p; i++ )
    {
        if ( mutation() )
        {
            for ( j=1; j<=NUMBER_OF_TRIALS; j++ )
            {
                x = random(1,n-an[ toSort[i].index ].row + 1);
                y = random(1,m-an[ toSort[i].index ].col + 1);
             //   printf("\ndbg %d %d %d\n",toSort[i].index,x,y);

                flag = 0;

                for ( int g=x; g < x + an[ toSort[i].index ].row; g++ )
                    for ( int h=y; h < y + an[ toSort[i].index ].col; h++ )
                        if ( an[ toSort[i].index ].pat[g-x+1][h-y+1] )
                            if ( matLoc[g][h] < an[ toSort[i].index ].thr )
                            {
                                flag = 1;
                                break;
                            }

                if ( !flag )
                {
                //    printf("\n dbg2 %d %d %d\n",toSort[i].index,x,y);
                    childInTime.index[ toSort[i].index ] = childI;
                    childInTime.row[ toSort[i].index ] = x;
                    childInTime.col[ toSort[i].index ] = y;
                    childI++;

                    for ( int g=x; g < x + an[ toSort[i].index ].row; g++ )
                        for ( int h=y; h < y + an[ toSort[i].index ].col; h++ )
                            if ( an[ toSort[i].index ].pat[g-x+1][h-y+1] )
                            {
                                childInTime.fitness += matLoc[g][h];
                                matLoc[g][h] /= an[ toSort[i].index ].k;
                            }
                    break;
                }
            }
        }
        else
        {
            indPar = random(0,1);

            x = parents[indPar]->row[ toSort[i].index ];
            y = parents[indPar]->col[ toSort[i].index ];

            flag = 0;

                for ( int g=x; g < x + an[ toSort[i].index ].row; g++ )
                    for ( int h=y; h < y + an[ toSort[i].index ].col; h++ )
                        if ( an[ toSort[i].index ].pat[g-x+1][h-y+1] )
                            if ( matLoc[g][h] < an[ toSort[i].index ].thr )
                            {
                                flag = 1;
                                break;
                            }

            if (!flag)
            {
                childInTime.index[ toSort[i].index ] = childI;
                childInTime.col[ toSort[i].index ] = parents[indPar]->col[ toSort[i].index ];
                childInTime.row[ toSort[i].index ] = parents[indPar]->row[ toSort[i].index ];
                childI++;

                for ( int g=x; g < x + an[ toSort[i].index ].row; g++ )
                    for ( int h=y; h < y + an[ toSort[i].index ].col; h++ )
                        if ( an[ toSort[i].index ].pat[g-x+1][h-y+1] )
                        {
                            childInTime.fitness += matLoc[g][h];
                            matLoc[g][h] /= an[ toSort[i].index ].k;
                        }
            }
            else
            {
                indPar^=1;

                x = parents[indPar]->row[ toSort[i].index ];
                y = parents[indPar]->col[ toSort[i].index ];

                flag = 0;

                    for ( int g=x; g < x + an[ toSort[i].index ].row; g++ )
                        for ( int h=y; h < y + an[ toSort[i].index ].col; h++ )
                            if ( an[ toSort[i].index ].pat[g-x+1][h-y+1] )
                                if ( matLoc[g][h] < an[ toSort[i].index ].thr )
                                {
                                    flag = 1;
                                    break;
                                }

                if (!flag)
                {
                    childInTime.index[ toSort[i].index ] = childI;
                    childInTime.col[ toSort[i].index ] = parents[indPar]->col[ toSort[i].index ];
                    childInTime.row[ toSort[i].index ] = parents[indPar]->row[ toSort[i].index ];
                    childI++;

                    for ( int g=x; g < x + an[ toSort[i].index ].row; g++ )
                        for ( int h=y; h < y + an[ toSort[i].index ].col; h++ )
                            if ( an[ toSort[i].index ].pat[g-x+1][h-y+1] )
                            {
                                childInTime.fitness += matLoc[g][h];
                                matLoc[g][h] /= an[ toSort[i].index ].k;
                            }
                }
            }
        }
    }

    return childInTime;
}

int selection(int par)
{
    int chances[POPULATION_SIZE];chances[0]=0;
    long long sum=0;
    for(int i=1;i<=POPULATION_SIZE;i++)
        sum+=population[par][i].fitness;
    for(int i=1;i<=POPULATION_SIZE;i++)
    chances[i]=chances[i-1]+(((double)population[par][i].fitness/(double)sum)*RAND_MAX);
    int r,act;
        act=0;
        r=rand();
        for(int i=1;i<=POPULATION_SIZE;i++)
            if(r>chances[i]) act++;

        if(act>POPULATION_SIZE) act=POPULATION_SIZE;
    return act;
}
int curpop=0;
bool ff(const chromosome &u,const chromosome &v)
{
    if(u.fitness>v.fitness) return true;
    return false;
}
void printchrom(chromosome &u)
{
    printf("%d\n",u.fitness);
    data tmp[127];
    for(int i=1;i<=p;i++)
    {
        tmp[i].index=i;
        tmp[i].rank=p-u.index[i];
    }
    sort(tmp+1,tmp+p+1,f);
    for(int i=1;i<=p;i++)
    if(tmp[i].rank==-1) break;
    else
    {
       printf("%d %d %d\n",tmp[i].index,u.row[tmp[i].index],u.col[tmp[i].index]);
    }
}
void solve()
{
    int i,j,par=curpop,q=curpop^1,x,y;
    chromosome winer;
    int best=0;
    sort (population[par]+1,population[par]+POPULATION_SIZE+1,ff);

    while(((double)(clock())/(double)(CLOCKS_PER_SEC))<1.92)
    {
        for ( j=1; j<=OLD; j++ ) population[q][j] = population[par][j];
        for ( j=OLD+1; j<=POPULATION_SIZE; j++ )
        {
            x = selection(par);
            y = selection(par);
            population[q][j] = crossover(population[par][x],population[par][y]);
        }

        sort (population[q]+1,population[q]+POPULATION_SIZE+1,ff);

        if(population[q][1].fitness>best)
        {
            best=population[q][1].fitness;
            winer=population[1][1];
        }
        par^=1;
        q^=1;
    }
    printchrom(winer);
}

int main()
{
    srand(time(0));
	freopen("parash.in","r",stdin);
	freopen("parash.out","w",stdout);
    char c;

    scanf ("%d%d%d",&n,&m,&p);

    int i,j,l;

    for ( i=1; i<=n; i++ )
        for ( j=1; j<=m; j++ )
            scanf ("%d",&mat[i][j]);

    for ( i=1; i<=p; i++ )
    {
        scanf ("%d%d%d%d",&an[i].row,&an[i].col,&an[i].k,&an[i].thr);
        for ( j=1; j<=an[i].row; j++ )
        {
          //  scanf ("%c",&c);
            for ( l=1; l<=an[i].col; l++ )
            {
                do{
                    scanf ("%c",&c);} while((c!='1')&&(c!='0'));
                if ( c == '0' ) an[i].pat[j][l] = 0;
                else an[i].pat[j][l] = 1;
            }
        }
    }

    greedy_generator();
    solve();

   /* for ( i=1; i<=POPULATION_SIZE; i++ )
    {
        printf ("%d\n",population[0][i].fitness);
        for ( j=1; j<=p; j++ ) printf ("%d ",population[0][i].index[j]);
        printf ("\n");
        for ( j=1; j<=p; j++ ) printf ("%d %d\n",population[0][i].row[j],population[0][i].col[j]);
        printf ("\n");
    }*/

    /*chromosome u,v;
    u.index[1] = v.index[2] = 1;
    u.index[2] = v.index[1] = 2;
    u.row[1] = 2; u.col[1] = 1;
    u.row[2] = 1; u.col[2] = 3;
    v.row[1] = 3; v.col[1] = 3;
    v.row[2] = 2; v.col[2] = 4;
    chromosome nw = crossover(u,v);

    printf ("%d\n",nw.fitness);
    for ( i=1; i<=2; i++ ) printf ("%d ",nw.index[i]);
    printf ("\n");
    for ( i=1; i<=2; i++ ) printf ("%d %d\n",nw.row[i],nw.col[i]);*/
}
